class ActionJoinOsmGuidepostByKctref < Action # jgog-eg + jgog-ng
  include Rails.application.routes.url_helpers
  
  # nastaví proměnné podle catid (kde jsou zakódovány) + dělá sanity chcecky
  def setvars
    _, @kctref, @osmid = catid.split('|')
    @osm_guidepost = OsmGuidepost.find_by(osmid: @osmid)
    raise "OsmGuidepost mel bejt existing dle osmid #{@osmid}" if @osm_guidepost.nil?
    @guidepost = Guidepost.find_by_kctref(@kctref)  # může být případně nil pokud guidepost ještě neexistuje
    @short_action_name = "připojit OSM rozcestník podle/včetně kctref"
    @attrs = {
      action: linkify("připojit og:#{@osmid} podle/včetně kctref:#{@kctref}"),
      followup_url: @guidepost ?  guidepost_path(@guidepost) : osm_guidepost_path(@osm_guidepost)
    }
  end
  
  def perform
    @guidepost = Guidepost.new if @guidepost.nil? # pokud guidepost neexistuje, tak ho vyrob 
    res = @guidepost.update(
      osmid: @osmid,
      kctref: @kctref
    )
    if res && @guidepost.lat.nil? && @guidepost.lon.nil?  # přenes souřadnice pokud je guidepost nemá 
      @guidepost.update(
        lat: @osm_guidepost.lat,
        lon: @osm_guidepost.lon
      )
    end
    return res # !@guidepost.nil? && (@guidepost.osmid == @osmid) && (@guidepost.kctref == @kctref)
  end
end
